<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.8"/>
<title>Fittrack Weight Detection Module: $title</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Fittrack Weight Detection Module
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.8 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('Communication.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Macros</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Modules</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="contents">
<div class="textblock"><h1>Communication</h1>
<p>The communication between the Weight-Detection-Modules uses UART-based transmission and each module acts as a node in a daisy-chain.</p>
<div align="center">
<img src="dot_inline_dotgraph_1.png" alt="dot_inline_dotgraph_1.png" border="0" usemap="#dot_inline_dotgraph_1.map"/>
<map name="dot_inline_dotgraph_1.map" id="dot_inline_dotgraph_1.map"></map>
</div>
<h2>UART Communication Settings</h2>
<p>This section shows the UART settings used for the communication between the modules and the mainboard.</p><ul>
<li>Baudrate: 9600</li>
<li>Parity: None</li>
<li>Bits: 8</li>
<li>Stop-Bits: 1</li>
<li>Flow-Control: None</li>
</ul>
<p>The communication provides two different types of bytes to be transmitted. The index-byte and a data-byte.</p>
<h2>Index-Byte</h2>
<p>The Index-Byte consists of 5 bits for the index of the module and 3 bits for the status. </p><div class="fragment"><div class="line">---------------------------------</div>
<div class="line">| 7 | 6 | 5 | 4 | 3 | 2 | 1 | 0 |</div>
<div class="line">---------------------------------</div>
<div class="line">  |   |   |   |     . . .     |</div>
<div class="line">  |   |   |   |               +---------------Index[0]</div>
<div class="line">  |   |   |   |</div>
<div class="line">  |   |   |   +------------------------------ Index[4]       </div>
<div class="line">  |   |   +-----------------------------------Status[0]</div>
<div class="line">  |   +---------------------------------------Status[1]</div>
<div class="line">  +-------------------------------------------Status[2]</div>
<div class="line">  </div>
<div class="line">Status[0:2]:</div>
<div class="line">010 normal operation</div>
<div class="line">011 reserved</div>
<div class="line">100 is first and last module in the daisy chain</div>
<div class="line">101 first module in the daisy chain</div>
<div class="line">110 last module in the daisy chain</div>
<div class="line">111 error</div>
</div><!-- fragment --><h2>Data-Byte</h2>
<p>The data byte consists of 6 bits for the detection of the plates on the weight-stack. The remaining bits are reserved for future use.</p>
<div class="fragment"><div class="line">---------------------------------</div>
<div class="line">| 7 | 6 | 5 | 4 | 3 | 2 | 1 | 0 |</div>
<div class="line">---------------------------------</div>
<div class="line">  |   |   |    . . . . .      |</div>
<div class="line">  |   |   |                   +---------------Sensor[0]</div>
<div class="line">  |   |   |    </div>
<div class="line">  |   |   |          </div>
<div class="line">  |   |   +-----------------------------------Sensor[5]</div>
<div class="line">  |   +---------------------------------------0</div>
<div class="line">  +-------------------------------------------0</div>
<div class="line">Sensor[i], i = 0...5</div>
<div class="line">1 weight detected</div>
<div class="line">0 no weight detected</div>
</div><!-- fragment --><h2>Frames</h2>
<p>A fame for the direction off the Mainboard consists of a Index-Byte and a CRC16 (CCITT) as used in the Contiki OS. The first byte to be transmitted is the Index-Byte, followed by the CRC16. </p><div class="fragment"><div class="line">-------------------------------------------</div>
<div class="line">|Index-Byte|CRC16 Low-Byte|CRC16 High-Byte|</div>
<div class="line">-------------------------------------------</div>
</div><!-- fragment --><p>A frame for the direction to the Mainboard consists of the Index-Bytes and Data-Bytes of the modules, followed by a CRC16.</p>
<div class="fragment"><div class="line">-----------------------------------------------------------------------------------------------------</div>
<div class="line">|      Module 1      |       Module 2     | ... |      Module N      |          CRC16 CCITT         | </div>
<div class="line">-----------------------------------------------------------------------------------------------------</div>
<div class="line">|Index-Byte|Data-Byte|Index-Byte|Data-Byte| ... |Index-Byte|Data-Byte|CRC16 Low-Byte|CRC16 High-Byte|</div>
<div class="line">-----------------------------------------------------------------------------------------------------</div>
</div><!-- fragment --><h2>Protocol</h2>
<div align="center">
<img src="msc_inline_mscgraph_1.png" alt="msc_inline_mscgraph_1" border="0" usemap="#msc_inline_mscgraph_1.map"/>
<map name="msc_inline_mscgraph_1.map" id="msc_inline_mscgraph_1.map"></map>
</div>
<p> The above message sequence diagramm shows an overview of the communication between the Weight-Detection-Modules. A Index-Byte is sent to the first Module from the Mainboard, to initiate the beginning of the measurement. The first module increments the index and transmits it to the next module in the daisy-chain. The Last Module, that gets the Index-Byte and transmits a Frame, containing the Index-Byte, the Data-Byte and the CRC back to the next-to-last one. Every module appends the Index-Byte, Data-Byte and re-calculates the CRC.</p>
<dl class="section copyright"><dt>Copyright</dt><dd>Andreas Hirtenlehner, Gerald Ebmer, Lukas Pechhacker </dd></dl>
</div></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Aug 29 2016 12:25:43 for Fittrack Weight Detection Module by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.8 </li>
  </ul>
</div>
</body>
</html>
